/* eggdrop module to handle msg, notice, channel msg, channel notice, and
   elementary ctcp and ctcp-replies. */

#include <stdio.h>
#include <string.h>
#include <sys/time.h>
#include <varargs.h>
#include "eggdrop.h"

#define FINGER "is an EGGDROP bot, idle 0 seconds always."
#define SOURCE "email rpointe@eng.clemson.edu"
#define CLIENTINFO "FINGER PING ECHO ERRMSG VERSION SOURCE USERINFO CLIENTINFO DCC"

extern int serv;
extern int memused;
extern int backgrd;
extern int con_chan;
extern int term_z;
extern char botname[];
extern char helpbot[];
extern char version[];
extern char curchan[];
extern struct dcc_t dcc[];
extern int dcc_total;
extern char admin[];


/* ctcp embedded in a privmsg */
void gotctcp(ffrom,to,msg)
char *ffrom,*to,*msg;
{
  char from[121],nick[10],code[512]; char *p;
  strcpy(from,ffrom);
  split(code,msg); splitnick(nick,from);
  if (code[0]==0) { strcpy(code,msg); msg[0]=0; }
  /* unquote if necessary */
  p=strchr(msg,'\\');
  while (p!=NULL) {
    if (*(p+1)=='a') *(p+1)=1;
    strcpy(p,p+1);
    p=strchr(msg,'\\');
  }
  if (strcmp(code,"FINGER")==0)
    mprintf(serv,"NOTICE %s :%cFINGER %s %s%c\n",nick,1,botname,FINGER,1);
  else if ((strcmp(code,"PING")==0) || (strcmp(code,"ECHO")==0) ||
	   (strcmp(code,"ERRMSG")==0))
    mprintf(serv,"NOTICE %s :%c%s %s%c\n",nick,1,code,msg,1);
  else if (strcmp(code,"VERSION")==0)
    mprintf(serv,"NOTICE %s :%cVERSION %s using %s%c\n",nick,1,botname,version,
	    1);
  else if (strcmp(code,"SOURCE")==0)
    mprintf(serv,"NOTICE %s :%cSOURCE %s%c\n",nick,1,SOURCE,1);
  else if (strcmp(code,"USERINFO")==0)
    mprintf(serv,"NOTICE %s :%cUSERINFO %s%c\n",nick,1,admin,1);
  else if (strcmp(code,"CLIENTINFO")==0)
    mprintf(serv,"NOTICE %s :%cCLIENTINFO %s%c\n",nick,1,CLIENTINFO,1);
  else if (strcmp(code,"DCC")==0)
    gotdcc(nick,from,msg);
  else if (strcmp(code,"ACTION")==0)
    ;  /* ignore */
  else
    ;  /* ignore */
  if (strcmp(code,"DCC")!=0) {
    if ((to[0]=='#') || (to[0]=='&')) {
      if (strcmp(code,"ACTION")==0) {
	log(LOG_PUBLIC,"Action: %s %s",nick,msg);
      }
      else {
	log(LOG_PUBLIC,"CTCP %s: %s from %s (%s) to %s",code,msg,nick,from,to);
      }
    }
    else {
      if (strcmp(code,"ACTION")==0) {
	log(LOG_MSGS,"Action to %s: %s %s",to,nick,msg);
      }
      else {
	log(LOG_MSGS,"CTCP %s: %s from %s (%s)",code,msg,nick,from);
      }
    }
  }
}

/* ctcp embedded in a notice */
void gotctcpreply(ffrom,to,msg)
char *ffrom,*to,*msg;
{
  char from[81],nick[10],code[512]; char *p;
  strcpy(from,ffrom);
  split(code,msg); splitnick(nick,from);
  if (code[0]==0) { strcpy(code,msg); msg[0]=0; }
  /* unquote if necessary */
  p=strchr(msg,'\\');
  while (p!=NULL) {
    if (*(p+1)=='a') *(p+1)=1;
    strcpy(p,p+1);
    p=strchr(msg,'\\');
  }
  /* who cares? */
  if ((to[0]=='#') || (to[0]=='&'))
    log(LOG_PUBLIC,"CTCP reply %s: %s from %s (%s) to %s",code,msg,nick,from,
	to);
  else
    log(LOG_MSGS,"CTCP reply %s: %s from %s (%s) to %s",code,msg,nick,from,to);
}  

/* public msg on channel */
void gotpublic(from,to,msg)
char *from,*to,*msg;
{
  char nick[10];
  detect_flood(from,_PRIVMSG,1);
  splitnick(nick,from);
  if (strcasecmp(curchan,to)==0) log(LOG_PUBLIC,"<%s> %s",nick,msg);
  else log(LOG_PUBLIC,"<%s:%s> %s",nick,to,msg);
}

/* public notice on channel */
void gotpublicnotice(from,to,msg)
char *from,*to,*msg;
{
  char nick[10];
  detect_flood(from,_NOTICE,1);
  splitnick(nick,from);
  log(LOG_PUBLIC,"-%s:%s- %s",nick,to,msg);
}

/* private message */
void gotmsg(from,msg)
char *from,*msg;
{
  char to[81],nick[10],ctcp[512]; char *p,*p1;
  split(to,msg); fixcolon(msg);
  /* check for CTCP: */
  p=strchr(msg,1);
  while (p!=NULL) {
    p++; p1=p;
    while ((*p != 1) && (*p != 0)) p++;
    if (*p==1) { *p=0; strcpy(ctcp,p1); strcpy(p1-1,p+1); }
    else { strcpy(ctcp,p1); strcpy(p1-1,p); }
    detect_flood(from,_CTCP,0);
    gotctcp(from,to,ctcp);
    p=strchr(msg,1);
  }
  if (msg[0]==0) return;  /* oh. no msg. well forget it then! */
  if ((to[0]=='#') || (to[0]=='&')) {   /* it's a public msg */
    gotpublic(from,to,msg);
  } 
  else {
    detect_flood(from,_PRIVMSG,0);
    splitnick(nick,from);
    gotcmd(nick,from,msg);
  } 
}

/* private notice */
void gotnotice(from,msg)
char *from,*msg;
{
  char to[81],nick[10],ctcp[512]; char *p,*p1;
  split(to,msg); fixcolon(msg);  
  /* check for CTCP: */
  p=strchr(msg,1);
  while (p!=NULL) {
    p++; p1=p;
    while ((*p != 1) && (*p != 0)) p++;
    if (*p==1) { *p=0; strcpy(ctcp,p1); strcpy(p1-1,p+1); }
    else { strcpy(ctcp,p1); strcpy(p1-1,p); }
    detect_flood(from,_CTCP,0);
    gotctcpreply(from,to,ctcp);
    p=strchr(msg,1);
  }
  if (msg[0]==0) return;  /* oh. no msg. well forget it then! */
  if ((to[0]=='#') || (to[0]=='&')) {   /* it's a public msg */
    gotpublicnotice(from,to,msg);
  } 
  else {
    detect_flood(from,_NOTICE,0);
    /* server notice? */
    if ((from[0]==0) || (nick[0]==0)) {
      log(LOG_MISC,"-NOTICE- %s",msg);
    }
    else {
      splitnick(nick,from);
      log(LOG_MSGS,"-%s (%s)- %s",nick,from,msg);
    }
  }
}
